/**********************************************************************
 * Developed by;
 *	Neal Horman - neal@wanlink.com - http://www.wanlink.com
 *	Copyright (c) 2002 Neal Horman, All Rights Reserved
 *
 * This file/code may be used, modified, and distributed, for any 
 * purpose providing that this notice and the copyright notice above
 * is left fully intact, unaltered, and any modifications, additions, 
 * or bug fixes are clearly marked as such.
 *
 * This file/code is provided "as is" with no express or implied 
 * warranty of any kind whatsoever. The author expressly accepts no 
 * liability for any possible damages incurred as a result of it's use.
 * Use it at your own risk.
 *
 * Expect bugs.
 *
 * Portions Copyright (C) Microsoft Corporation
 *
 *		RCSID:  $Id$
 *
 * DESCRIPTION:
 *		application:	BlowFishDocView Demo
 *		source module:	DocumentBlowFish.h
 *
 **********************************************************************/

// DocumentBlowFish.h: interface for the CDocumentBlowFish class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DOCUMENTBLOWFISH_H__2899A7DA_FEA7_43B7_AECB_05BF64D9109E__INCLUDED_)
#define AFX_DOCUMENTBLOWFISH_H__2899A7DA_FEA7_43B7_AECB_05BF64D9109E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FileBlowFish.h"

// *** Cut and paste from afxpriv.h and modified to use CFileBlowFish
/////////////////////////////////////////////////////////////////////////////
// Robust file save support
// opens a temp file if modeCreate specified and enough free space
// renaming, etc occurs automatically if everything succeeds
class CMirrorFileBlowFish : public CFileBlowFish
{
// Implementation
public:
	virtual void Abort();
	virtual void Close();
	virtual BOOL Open(LPCTSTR lpszFileName, UINT nOpenFlags,
		CFileException* pError = NULL);
	static CString GetTempName(LPCTSTR pstrOriginalFile, BOOL bCreate);

protected:
	CString m_strMirrorName;
};

/////////////////////////////////////////////////////////////////////////////
class CDocumentBlowFish : public CDocument  
{
public:
	DECLARE_DYNCREATE(CDocumentBlowFish);

	CDocumentBlowFish();
	virtual ~CDocumentBlowFish();

	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	virtual CFile* GetFile( LPCTSTR lpszFileName, UINT nOpenFlags, CFileException* pError );
};

#endif // !defined(AFX_DOCUMENTBLOWFISH_H__2899A7DA_FEA7_43B7_AECB_05BF64D9109E__INCLUDED_)
